package net.mc_pandacraft.java.plugin.pandacraftutils.commands;

import java.util.Date;
import java.util.List;

import net.mc_pandacraft.java.plugin.pandacraftutils.modules.staff.StaffQueueManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.modules.staff.StaffQueueManager.WaitingPlayer;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;
import net.mc_pandacraft.java.util.TimeUtil;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import com.google.common.collect.ImmutableList;

public class CommandStaff extends AbstractCommandExecutor {

	public CommandStaff() {
		super("staff");
	}

	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String alias,
			String[] args) {
		
		
		
		StaffQueueManager staffManager = plugin.staffQueueManager;
		
		
		if (sender instanceof Player && !OnlinePlayerManager.get((Player)sender).isInStaff())
		{	// un joueur qui n'est pas du staff
			
			if (args.length == 0) {
				showHelp(sender);
				return true;
			}
			
			Player player = (Player) sender;
			
			WaitingPlayer wp = staffManager.getWaitingPlayer(player);
			
			if (args[0].equalsIgnoreCase("ajouter") && args.length > 1) {
				if (wp != null) {
					sender.sendMessage(ChatColor.RED+"Vous avez déjà envoyé un ticket :");
					displayTicket(sender, wp, false);
					sender.sendMessage(ChatColor.RED+"Faites "+ChatColor.GRAY+"/"+alias+" modifier <Message>"+ChatColor.RED+" pour modifier le message du ticket");
					return true;
				}
				
				String message = getLastParam(args, 1);
				
				staffManager.addWaitingPlayer(player, message);
				sender.sendMessage(ChatColor.GREEN+"Votre ticket a été envoyé :)");
				displayTicket(sender, wp, false);
				sender.sendMessage(ChatColor.RED+"Faites "+ChatColor.GRAY+"/"+alias+ChatColor.RED+" pour voir les commandes disponibles");
				return true;
			}
			if (args[0].equalsIgnoreCase("supprimer")) {
				if (wp == null) {
					sender.sendMessage(ChatColor.RED+"Il n'y a pas de ticket à supprimer");
					return true;
				}
				
				staffManager.removePlayer(player);
				return true;
			}
			if (args[0].equalsIgnoreCase("modifier") && args.length > 1) {
				if (wp == null) {
					sender.sendMessage(ChatColor.RED+"Il n'y a pas de ticket à modifier");
					return true;
				}
				
				String message = getLastParam(args, 1);
				
				wp.setMessage(message);
				sender.sendMessage(ChatColor.GREEN+"Votre ticket a été modifié :");
				displayTicket(sender, wp, false);
				return true;
			}
			if (args[0].equalsIgnoreCase("position")) {
				if (wp == null) {
					sender.sendMessage(ChatColor.RED+"Il n'y a aucun ticket à votre nom");
					return true;
				}
				
				int pos = staffManager.getPlayerPosition(player);
				sender.sendMessage(ChatColor.GOLD+"Votre ticket est à la position "+pos+" de la file d'attente");
				return true;
			}
			
			sender.sendMessage(ChatColor.RED+"Mauvaise utilisation : faites "+ChatColor.GRAY+"/"+alias+ChatColor.RED+" pour voir les commandes disponibles");
			return true;
		}
		
		// -------------
		// à partir de là, on fait partie du staff
		// -------------
		
		
		if (args.length == 0) {
			staffManager.showWaintingList(sender);
			sender.sendMessage(ChatColor.GOLD+"Pour connaitre les commandes, faites "+ChatColor.GRAY+"/staff ?");
			return true;
		}
		
		
		if (sender instanceof Player)
		{	// un joueur du staff IG
			
			Player staffPlayer = (Player) sender;
			WaitingPlayer selectedWP = staffManager.getSelectedWaitingPlayer((Player)sender);
			
			if (args[0].equalsIgnoreCase("selectionner") && args.length > 1)
			{
				if (selectedWP != null) {
					sender.sendMessage(ChatColor.RED+"Vous avez déjà sélectionné le joueur "+ChatColor.RESET+selectedWP.getPlayerDisplayName());
					sender.sendMessage(ChatColor.RED+"Faites "+ChatColor.RESET+"/"+alias+" finir"+ChatColor.RED+" pour en finir avec ce joueur");
					return true;
				}
				
				WaitingPlayer wp = staffManager.getWaitingPlayer(args[1]);
				
				if (wp == null) {
					sender.sendMessage(ChatColor.RED+"Ce joueur n'est pas dans la file d'attente");
					return true;
				}
				// on vérifie si un membre du staff ne s'occupe pas déjà du joueur
				if (wp.getStaffPlayerName() != null) {
					sender.sendMessage(ChatColor.RED+wp.getStaffPlayerName()+" s'occupe déjà de ce joueur");
					return true;
				}
				
				wp.setStaffPlayer(staffPlayer);
				
				Player p = plugin.getServer().getPlayerExact(wp.getPlayerName());
				if (p != null && p.isOnline()) {
					// le joueur est en ligne
					((Player)sender).teleport(p.getLocation());
					
					sender.sendMessage(ChatColor.GREEN+"-----------------------------------------------");
					displayTicket(sender, wp, true);
					sender.sendMessage(ChatColor.GREEN+"Vous avez été téléporté vers ce joueur");
					sender.sendMessage(ChatColor.GREEN+"-----------------------------------------------");

					p.sendMessage(ChatColor.GREEN+"-----------------------------------------------");
					p.sendMessage(((Player)sender).getDisplayName()+ChatColor.RESET+ChatColor.GREEN+" s'occupe maintenant de vous :)");
					p.sendMessage(ChatColor.GREEN+"-----------------------------------------------");
					
				}
				else {
					// le joueur n'est pas en ligne
					((Player)sender).teleport(wp.getLocation());
					
					sender.sendMessage(ChatColor.GREEN+"-----------------------------------------------");
					displayTicket(sender, wp, true);
					sender.sendMessage(ChatColor.GREEN+"Vous avez été téléporté vers l'endroit concerné par la demande du joueur");
					sender.sendMessage(ChatColor.GREEN+"-----------------------------------------------");
				}
				
				
				return true;
			}
			if (args[0].equalsIgnoreCase("finir"))
			{
				if (selectedWP == null) {
					sender.sendMessage(ChatColor.RED+"Vous ne vous occupez actuellement de personne. Faites "+ChatColor.GRAY+"/staff"+ChatColor.RED+" pour voir si vous pouvez aider un joueur");
					return true;
				}
				
				staffManager.removePlayer(selectedWP.getPlayerName());
				
				sender.sendMessage(ChatColor.GREEN+selectedWP.getPlayerDisplayName()+ChatColor.RESET+ChatColor.GREEN+" a été retiré de la file d'attente");
				
				Player p = plugin.getServer().getPlayerExact(selectedWP.getPlayerName());
				if (p != null && p.isOnline()) {
					p.sendMessage(ChatColor.RED+"Vous avez été retiré de la file d'attente");
				}
				
				return true;
				
			}
			if (args[0].equalsIgnoreCase("annuler"))
			{
				if (selectedWP == null) {
					sender.sendMessage(ChatColor.RED+"Vous ne vous occupez actuellement de personne. Faites "+ChatColor.GRAY+"/staff"+ChatColor.RED+" pour voir si vous pouvez aider un joueur");
					return true;
				}
				
				selectedWP.setStaffPlayer(null);
				
				Player p = plugin.getServer().getPlayerExact(selectedWP.getPlayerName());
				if (p != null && p.isOnline()) {
					p.sendMessage(ChatColor.RED+staffPlayer.getDisplayName()+ChatColor.RED+" n'a pas la possibilité de traiter votre demande :/"
							+ "Mais ne vous en faites pas, vous avez été remis en file d'attente et un autre membre du staff peut vous prendre en charge ;)");
				}
				
				
				sender.sendMessage(ChatColor.GREEN+selectedWP.getPlayerDisplayName()+ChatColor.RESET+ChatColor.GREEN+" a été remis en attente");
				
				return true;
				
			}
			
			
			
		}
		
		
		
		
		
		// les commandes ci dessous peuvent être pris en charge par la console, ou comme un membre du staff IG
		

		if (args[0].equalsIgnoreCase("?"))
		{	// affichage de l'aide
			showHelp(sender);
			return true;
		}
		
		if (args[0].equalsIgnoreCase("supprimer") && args.length > 1)
		{
			WaitingPlayer wp = staffManager.getWaitingPlayer(args[1]);
			if (wp == null) {
				sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas dans la file");
				return true;
			}
			
			staffManager.removePlayer(wp.getPlayerName());
			Player p = plugin.getServer().getPlayerExact(wp.getPlayerName());
			if (p != null && p.isOnline()) {
				p.sendMessage(ChatColor.RED+"Vous avez été retiré de la file d'attente");
			}
			
			sender.sendMessage(ChatColor.GREEN+wp.getPlayerName()+ChatColor.RESET+ChatColor.GREEN+" a été retiré de la file d'attente");
			
			return true;
			
		}
		if (args[0].equalsIgnoreCase("ajouter") && args.length > 2)
		{

			Player p = plugin.getServer().getPlayer(args[1]);
			
			if (p == null || !p.isOnline()) {
				sender.sendMessage(ChatColor.RED+"Le joueur n'existe pas ou n'est pas en ligne");
				return true;
			}
			
			WaitingPlayer wp = staffManager.getWaitingPlayer(p.getName());
			if (wp != null) {
				sender.sendMessage(ChatColor.RED+"Le joueur a déjà son ticket en attente");
				return true;
			}
			
			String message = ChatColor.ITALIC+"(Ajouté par "+sender.getName() +") "+ ChatColor.RESET+getLastParam(args, 2);
			
			
			staffManager.addWaitingPlayer(p, message);
			
			sender.sendMessage(ChatColor.GREEN+"Vous venez d'ajouter "+p.getDisplayName()+ChatColor.RESET+ChatColor.GREEN+" dans la file d'attente");
			
			p.sendMessage(ChatColor.GREEN+sender.getName()+" vous a ajouté dans la file d'attente pour traiter votre demande plus tard");
			return true;
		}
		if (args[0].equalsIgnoreCase("modifier") && args.length > 2)
		{

			WaitingPlayer wp = staffManager.getWaitingPlayer(args[1]);
			if (wp == null) {
				sender.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas dans la file");
				return true;
			}
			
			String message = ChatColor.ITALIC+"(Modifié par "+sender.getName() +") "+ ChatColor.RESET+getLastParam(args, 2);
			
			wp.setMessage(message);
			
			sender.sendMessage(ChatColor.GREEN+"Le message de "+ChatColor.RESET+wp.getPlayerDisplayName()+ChatColor.GREEN+" a été modifié");
			
			Player p = plugin.getServer().getPlayerExact(wp.getPlayerName());
			if (p != null && p.isOnline()) {
				p.sendMessage(ChatColor.GOLD+sender.getName()+" a modifié le message de votre ticket "+ChatColor.GRAY+"/staff"+ChatColor.GOLD+" :");
				displayTicket(p, wp, false);
			}
			
			return true;
		}
		
		
		
		
		
		sender.sendMessage(ChatColor.RED+"Mauvaise utilisation : faites "+ChatColor.GRAY+"/"+alias+" ?"+ChatColor.RED+" pour voir les commandes disponibles");
		return true;
			
		
		
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	public static final List<String> FIRST_ARG_PLAYERS = ImmutableList.of("ajouter", "supprimer", "modifier", "position");
	public static final List<String> FIRST_ARG_STAFF = ImmutableList.of("?", "ajouter", "modifier", "supprimer", "selectionner", "annuler", "finir");
	public static final List<String> FIRST_ARG_CONSOLE = ImmutableList.of("?", "ajouter", "modifier", "supprimer");
	
	@Override
	public List<String> onTabComplete(CommandSender sender, Command cmd, String alias, String[] args) {
		
		StaffQueueManager staffManager = plugin.staffQueueManager;
		
		if (sender instanceof Player && !OnlinePlayerManager.get((Player)sender).isInStaff())
		{	// pour les joueurs
			if (args.length == 1) {
				return getTabProposalFromToken(args[0], FIRST_ARG_PLAYERS);
			}
			if (args.length > 1) {
				if (args[0].equalsIgnoreCase("ajouter"))
					return null;
				if (args[0].equalsIgnoreCase("modifier"))
					return null;
			}
		}
		else if (sender instanceof Player)
		{	// pour le staff connecté
			if (args.length == 1)
				return getTabProposalFromToken(args[0], FIRST_ARG_STAFF);
			if (args.length > 1) {
				if (args[0].equalsIgnoreCase("ajouter")) {
					if (args.length == 2) {
						List<String> playerCanBeAdd = OnlinePlayerManager.getNamesOnlyVisible((Player) sender);
						playerCanBeAdd.removeAll(staffManager.getWaitingPlayerNames());
						return getTabProposalFromToken(args[1], playerCanBeAdd);
					}
					if (args.length > 2)
						return null;
				}
				if (args[0].equalsIgnoreCase("modifier")) {
					if (args.length == 2)
						return getTabProposalFromToken(args[1], staffManager.getWaitingPlayerNames());
					if (args.length > 2)
						return null;
				}
				if (args[0].equalsIgnoreCase("supprimer"))
					if (args.length == 2)
						return getTabProposalFromToken(args[1], staffManager.getWaitingPlayerNames());
				if (args[0].equalsIgnoreCase("selectionner"))
					if (args.length == 2)
						return getTabProposalFromToken(args[1], staffManager.getWaitingPlayerNames());
			}
		}
		else
		{	// pour la console et le reste (pas les joueurs)
			if (args.length == 1)
				return getTabProposalFromToken(args[0], FIRST_ARG_CONSOLE);
			if (args.length > 1) {
				if (args[0].equalsIgnoreCase("ajouter")) {
					if (args.length == 2) {
						List<String> playerCanBeAdd = OnlinePlayerManager.getNamesOnlyVisible(null);
						playerCanBeAdd.removeAll(staffManager.getWaitingPlayerNames());
						return getTabProposalFromToken(args[1], playerCanBeAdd);
					}
					if (args.length > 2)
						return null;
				}
				if (args[0].equalsIgnoreCase("modifier")) {
					if (args.length == 2)
						return getTabProposalFromToken(args[1], staffManager.getWaitingPlayerNames());
					if (args.length > 2)
						return null;
				}
				if (args[0].equalsIgnoreCase("supprimer"))
					if (args.length == 2)
						return getTabProposalFromToken(args[1], staffManager.getWaitingPlayerNames());
			}
		}
		
		
		return NO_PROPOSAL;
	}
	
	
	
	

	private void showHelp(CommandSender sender) {
		
		String[] messages = null;
		if (sender instanceof Player && !OnlinePlayerManager.get((Player)sender).isInStaff())
		{	// pour les joueurs
			String[] m = {
					ChatColor.GOLD+"----- Ticket / file d'attente staff -----",
					ChatColor.GOLD+"Les tickets vous permettent de demander assistance à un membre du staff",
					ChatColor.GRAY+"/staff ajouter <Message>"+ChatColor.GOLD+" pour ajouter un ticket dans la file d'attente",
					ChatColor.GRAY+"/staff supprimer"+ChatColor.GOLD+" pour supprimer votre ticket de la file d'attente",
					ChatColor.GRAY+"/staff modifier <Message>"+ChatColor.GOLD+" pour modifier le message de votre ticket",
					ChatColor.GRAY+"/staff position"+ChatColor.GOLD+" pour connaitre votre position dans la file d'attente",
					ChatColor.GOLD+"------------------------------------------"
			};
			messages = m;
		}
		else if (sender instanceof Player)
		{	// pour le staff connecté
			String[] m = {
					ChatColor.GOLD+"----- Ticket / file d'attente staff -----",
					ChatColor.GRAY+"/staff"+ChatColor.GOLD+" pour voir la liste des tickets",
					ChatColor.GRAY+"/staff ajouter <Pseudo> <Message>"+ChatColor.GOLD+" pour ajouter un ticket dans la file d'attente",
					ChatColor.GRAY+"/staff supprimer <Pseudo>"+ChatColor.GOLD+" pour supprimer le ticket d'un joueur de la file d'attente",
					ChatColor.GRAY+"/staff modifier <Pseudo> <Message>"+ChatColor.GOLD+" pour modifier le message du ticket d'un joueur",
					ChatColor.GRAY+"/staff selectionner <Pseudo>"+ChatColor.GOLD+" pour prendre en charge un joueur en attente",
					ChatColor.GRAY+"/staff annuler"+ChatColor.GOLD+" quand vous ne pouvez pas régler le problème du joueur que vous avez pris en charge",
					ChatColor.GRAY+"/staff finir"+ChatColor.GOLD+" quand vous avez réglé le problème du joueur que vous avez pris en charge",
					ChatColor.GOLD+"------------------------------------------"
			};
			messages = m;
		}
		else
		{	// pour la console et le reste (pas les joueurs)
			String[] m = {
					ChatColor.GOLD+"----- Ticket / file d'attente staff -----",
					ChatColor.GRAY+"/staff"+ChatColor.GOLD+" pour voir la liste des tickets",
					ChatColor.GRAY+"/staff ajouter <Pseudo> <Message>"+ChatColor.GOLD+" pour ajouter un ticket dans la file d'attente",
					ChatColor.GRAY+"/staff supprimer <Pseudo>"+ChatColor.GOLD+" pour supprimer le ticket d'un joueur de la file d'attente",
					ChatColor.GRAY+"/staff modifier <Pseudo> <Message>"+ChatColor.GOLD+" pour modifier le message du ticket d'un joueur",
					ChatColor.GOLD+"---------------------------------------------"
			};
			messages = m;
		}
		sender.sendMessage(messages);
	}
	

	
	
	
	
	
	
	
	public void displayTicket(CommandSender sender, WaitingPlayer wp, boolean withPlayerName) {
		String out = (withPlayerName) ? wp.getPlayerDisplayName()+ChatColor.RESET+" : " : "";
		
		out += wp.getMessage()+" - "+ChatColor.ITALIC+"Il y a "+TimeUtil.durationToString((new Date()).getTime() - wp.getDate().getTime());
		
		sender.sendMessage(out);
	}
	
	
	
	

}
