package net.mc_pandacraft.java.plugin.pandacraftutils.listener;

import net.mc_pandacraft.java.plugin.pandacraftutils.PandacraftUtils;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;

import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerAchievementAwardedEvent;
import org.bukkit.event.player.PlayerBucketEmptyEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerEggThrowEvent;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.player.PlayerToggleFlightEvent;
import org.bukkit.event.player.PlayerToggleSneakEvent;
import org.bukkit.event.player.PlayerToggleSprintEvent;

public class PlayerListener implements Listener {
	private PandacraftUtils plugin = PandacraftUtils.getInstance();
	
	

	public PlayerListener()
	{
        plugin.getServer().getPluginManager().registerEvents(this, plugin);
	}
	
	
	
	
	
	

	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.LOWEST)
	public void onPlayerJoin_Lowest(PlayerJoinEvent event) {
		OnlinePlayerManager.getInstance().onPlayerJoin(event);
	}
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerJoin(PlayerJoinEvent event) {
		plugin.vanillaMessageManager.onPlayerJoin(event);
		plugin.staffQueueManager.onPlayerJoin(event);
	}
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.HIGHEST)
	public void onPlayerJoin_Highest(PlayerJoinEvent event) {
		plugin.ghostManager.onPlayerJoin(event);
	}
	
	
	
	


	
	
	
	

	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerQuit(PlayerQuitEvent event) {
		plugin.vanillaMessageManager.onPlayerQuit(event);
		plugin.staffQueueManager.onPlayerQuit(event);
	}
	@EventHandler(ignoreCancelled=false,priority=EventPriority.HIGHEST)
	public void onPlayerQuit_Highest(PlayerQuitEvent event) {
		OnlinePlayerManager.getInstance().onPlayerQuit(event);
	}
	
	
	
	

	
	
	

	@EventHandler(ignoreCancelled=false,priority=EventPriority.LOWEST)
	public void onAsyncPlayerChat_Lowest(AsyncPlayerChatEvent event) {
		plugin.calculatorManager.onAsyncPlayerChat(event);
	}
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onAsyncPlayerChat(AsyncPlayerChatEvent event) {
		plugin.afkManager.onAsyncPlayerChat(event);
	}

	@EventHandler(ignoreCancelled=true,priority=EventPriority.HIGH)
	public void onAsyncPlayerChat_High_IgnoreCancelled(AsyncPlayerChatEvent event) {
		plugin.chatAnalysisManager.onAsyncPlayerChat(event);
	}
	
	@EventHandler(ignoreCancelled=true,priority=EventPriority.HIGHEST)
	public void onAsyncPlayerChat_Highest_IgnoreCancelled(AsyncPlayerChatEvent event) {
		plugin.ghostManager.onAsyncPlayerChat(event);
	}
	
	
	
	
	
	
	
	
	
	

	@EventHandler(ignoreCancelled=false,priority=EventPriority.LOWEST)
	public void onPlayerCommandPreprocess_Lowest(PlayerCommandPreprocessEvent event) {
		OnlinePlayerManager.get(event.getPlayer()).getEssentialsUser().setDisplayNick();
	}
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerCommandPreprocess(PlayerCommandPreprocessEvent event) {
		plugin.afkManager.onPlayerCommandPreprocess(event);
	}

	@EventHandler(ignoreCancelled=false,priority=EventPriority.HIGHEST)
	public void onPlayerCommandPreprocess_Highest(PlayerCommandPreprocessEvent event) {
		plugin.commandAliasManager.onPlayerCommandPreprocess(event);
	}
	
	@EventHandler(ignoreCancelled=true,priority=EventPriority.HIGHEST)
	public void onPlayerCommandPreprocess_Highest_IgnoreCancelled(PlayerCommandPreprocessEvent event) {
		plugin.chatAnalysisManager.onPlayerCommandPreprocess(event);
	}
	
	
	
	
	
	

	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerDeath(PlayerDeathEvent event) {
		plugin.vanillaMessageManager.onPlayerDeath(event);
	}
	
	
	
	
	
	
	
	
	
	
	
	

	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerAchievementAwarded(PlayerAchievementAwardedEvent event) {
		plugin.vanillaMessageManager.onPlayerAchievementAwarded(event);
	}
	
	
	
	
	
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerMove(PlayerMoveEvent event) {
		plugin.afkManager.onPlayerMove(event);
		plugin.creativCheatManager.onPlayerMove(event);
	}
	
	
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerInteract (PlayerInteractEvent event)
	{
		plugin.afkManager.onPlayerInteract(event);
	}

	
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerInteractEntity (PlayerInteractEntityEvent event) {
		plugin.afkManager.onPlayerInteractEntity(event);
		plugin.tamedEntityProtectManager.onPlayerInteractEntity(event);
	}

	
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerTeleport (PlayerTeleportEvent event) {
		plugin.afkManager.onPlayerTeleport(event);
		plugin.worldBorderManager.onPlayerTeleport(event);
	}

	
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerToggleSprint (PlayerToggleSprintEvent event)
	{
		plugin.afkManager.onPlayerToggleSprint(event);
	}
	
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerToggleFlight (PlayerToggleFlightEvent event)
	{
		plugin.afkManager.onPlayerToggleFlight(event);
	}
	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerToggleSneak (PlayerToggleSneakEvent event)
	{
		plugin.afkManager.onPlayerToggleSneak(event);
	}

	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerDropItem (PlayerDropItemEvent event)
	{
		plugin.afkManager.onPlayerDropItem(event);
	}

	
	
	
	
	
	
	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerEggThrow (PlayerEggThrowEvent event)
	{
		plugin.afkManager.onPlayerEggThrow(event);
	}
	
	
	
	
	

	@EventHandler(ignoreCancelled=false,priority=EventPriority.NORMAL)
	public void onPlayerBucketEmpty(PlayerBucketEmptyEvent event) {
		plugin.noPvpProtectManager.onPlayerBucketEmpty(event);
	}
	
	
	
	
	

}
